rem Analog digital conversion on 80535
rem Copyright 1993-1997 by Dr. O'Niel Annand Valentin Som
rem register ADCON ($D8): bit 0-2 channel number
rem                       bit 3  continuously (1), single (0)
rem                       bit 4  busy (1), ready (0)
rem                       bit 6  system clock enable
rem                       bit 7  baud rate enable
rem register DAPR ($DA): conversion range, for example
rem $00 = 0-5 Volt, $08 = 0-2.5 Volt, $80 = 2.5-5 Volt
rem $04 = 0-1.25 Volt, $48 = 1.25-2.5 Volt, $8C = 2.5-3.75 Volt
rem $C0 = 3.75-5 Volt. 
rem register ADDAT ($D9): result of A/D conversion 8 bit

REGISTER adcon $D8
REGISTER dapr $DA
REGISTER addat $D9

start:
         INPUT "Which channel (0-7)? " kanal
         REM single conversion
         x = ( kanal or $10 ) and $3F
         REM reset A/D
         y = ( adcon and $C0 ) or x
         adcon = y

         rem select range 0..5 Volt
         dapr = 0
         REM wait until not busy

         asm jb adcon.4,*+0

         PRINT "Result of channel " kanal " is " addat
         goto start
