rem Machine control example
rem Copyright 1993-1997 by Dr. O'Niel Annand Valentin Som
rem include macro file to save and restore registers on interrupts

ASM $INCLUDE REGISTER.ASM

rem PORT1 is connected in this example
rem Pin 1 = input, set when all is OK
rem Pin 2 = output, open ventile
rem Pin 3 = output, alarm when error occurs
rem Pin 4 = output, open auxilary ventile

onint0 gosub container_full
onint1 gosub ventile_error
start: port1 = $FF
       enable all
waiting:
       if bit port1.1 = 1 then gosub ok_signal
       goto waiting

container_full:
       ASM saveregs
       set port1.2
       wait 20 : REM wait 20 seconds
       enable int0
       ASM restoreregs
       ireturn

ok_signal:
       reset port1.3
       enable all
       return

ventile_error:
       ASM saveregs
       disable all : rem disable interrupts
       print "Ventile does not work!!!"
       set port1.3 : rem switch error lamp on
       repeat
         reset port1.4 : rem activate auxilary ventile
         wait 10
         set port1.4
         wait 5 : rem wait 5 seconds
       until bit port1.1 = 1
       Print "Ventile is working."
       enable all
       ASM restoreregs 
       ireturn
