rem Beispiel einer hypothetischen Maschinensteuerung fr NILIBAS
rem Copyright 1994 by O'Niel Annand Valentin Som

rem In einer realen Steuerung mssen am Anfang jeder Interrupt-
rem Routine alle Register gesichert werden und am Ende (vor reti)
rem wieder hergestellt werden.
rem Ein Unterprogramm kann nicht verwendet werden, da dadurch auch
rem der Stackpointer verndert wrde.

rem Das Sichern geschieht durch PUSH-Befehle.
rem Beim Wiederherstellen mssen die Register in umgekehreter Reihen-
rem folge durch POP vom Stack geholt werden.
rem Es empfiehlt sich, diese Befehle als Macro zu definieren.
rem Eine Makrodatei finden Sie auf dieser Diskette als REGISTER.ASM
rem so wird diese Datei eingebunden: 

ASM $INCLUDE REGISTER.ASM

rem PORT1 hat in diesem Beispiel folgende Anschlsse:
rem Pin 1 = Eingang fr Alles OK
rem Pin 2 = Ausgabe Ablaventil ffnen
rem Pin 3 = Ausgang fr Fehlermeldung (z.B Kontrollampe)
rem Pin 4 = Ausgang zum ffnen eines Hilfsventils

onint0 gosub behaelter_voll
onint1 gosub ventil_klemmt

start: port1 = $FF : rem Hier startet das Hauptprogramm
       enable all  : rem Alle Interrupts freigeben

schleife:
       if bit port1.1 = 1 then gosub ok_signal
       goto schleife

behaelter_voll:
       ASM saveregs
       set port1.2
       wait 20 : REM warte 20 Sekunden

       enable int0
       ASM restoreregs
       ireturn : rem Interrupt beenden

ok_signal:
       reset port1.3
       enable all
       return

ventil_klemmt:
       ASM saveregs
       disable all : rem Alle Interrupts abschalten
       print "Ventil klemmt"
       set port1.3 : rem Fehlerlampe anschalten
       repeat
         reset port1.4 : rem Hilfsventil aktivieren
         wait 10
         set port1.4
         wait 5 : rem warte 5 Sekunden
       until bit port1.1 = 1
       Print "Ventil ist wieder OK"
       enable all
       ASM restoreregs 
       ireturn
