rem Timer 2 programming for 8032
rem Copyright 1993-1997 by Dr. O'Niel Annand Valentin Som

         rem Bit addresses
         register    tf2     $CF
         register    exf2    $CE
         register    rclk    $CD
         register    tclk    $CC
         register    exen2   $CB
         register    tr2     $CA
         register    c/t2    $C9
         register    cp/rl2  $C8
         
         rem Byte addresses
         register    t2con   $C8
         register    rcap2l  $CA
         register    rcap2h  $CB
         register    tl2     $CC
         register    th2     $CD

         rem initialize reload values for timer 2
         rem example $8000 -> RCAP2
         rcap2l = 0
         rcap2h = $80

         rem initialize register T2CON
         rem example TF2=0, EXF2=0, RCLK=0, TCLK=0
         rem EXEN2=0, TR2=1, C/T2=0, CP/RL2=0

         t2con = $04

         rem initialize a timer 2 interrupt
         ontim2 gosub timer_2_int
         enable tim2
         enable any
         counter = 0
         end

timer_2_int:
         inc counter
         if counter = 255
           then print "Timer 2 interrupt"
           else : endif
         rem clear timer 2 overflow bit
         reset tf2
         reset exf2
         rem other commands go here
         ireturn
