REM Scheibenwischersteuerung Copyright 1994 by O'Niel A. V. Som

REM An Port1 Pin 0 ist ein Taster zum Einstellen des Intervalls 
REM angeschlossen, beim Tastendruck wird eine Verbindung des Pins mit
REM der Masse hergestellt, in Ruhe liegt er auf +5 Volt.

REM Mit Port1 Pin 7 wird ein Relais angesteuert. "1" an diesem Pin 
REM bedeutet: Relais an.

REM An den externen Interrupteingang 1 wird ein Schalter zum Rcksetzen
REM angeschlossen. Zum Zurcksetzen stellt dieser Schalter eine Ver-
REM bindung mit Masse her, in Ruhe auf +5 Volt.
         
REM Bei Auslsen des externen Interrupts 1 fngt das Programm von
REM vorne an, d.h. die Zeitschleife kann neu gewhlt werden.
REM Anstelle eines Interrupts kann man auch einfach den Mikrocontroller
REM kurz aus- und wieder anschalten.

REM Die Anzeige der Werte ber die serielle Schnittstelle dient nur
REM zur Kontrolle, ebenso die Anzeige des Wortes "Wisch".

ASM $INCLUDE REGISTER.ASM
         onint1 goto zuruecksetzen
start:
         REM Alle Interrupts freigeben
         enable all
         enable int1

         REM Zhler auf Null setzen
         zaehler% = 0
         warten% = 0
         von_vorne = 0

         port1 = 128
         wait 1
         print "Wisch"
         REM Mit PORT1 = 1 wird der Pin 0 des Ports auf Eingabe geschaltet
         port1 = 1

         REM Warten bis Taste gedrckt ist
         repeat
           inc zaehler%
           wait 1
           print zaehler%
         until port1 = 0
         port1 = 1

         REM Wischer periodisch bettigen, wenn Zeitintervall abgelaufen ist
nochmal:
         repeat
           REM von_vorne ist nur nach einem Interrupt auf 1 gesetzt.
           if von_vorne = 1 goto start
           inc warten%
           wait 1
           print "z=" zaehler% " w=" warten%
         until warten% > zaehler%
         port1 = 128
         wait 1
         print "Wisch"
         port1 = 1
         warten% = 0
         goto nochmal

zuruecksetzen:
         REM Diese Routine wird bei einem Interrupt 1 ausgefhrt.
         ASM saveregs
         von_vorne = 1
         ASM restoreregs
         reti

